
// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the CRASHHANDLER_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// CRASHHANDLER_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.
#ifdef CRASHHANDLER_EXPORTS
#define CRASHHANDLER_API __declspec(dllexport)
#else
#define CRASHHANDLER_API __declspec(dllimport)
#endif

#include <windows.h>
#include <exception>

// This class is exported from the CrashHandler.dll
class CRASHHANDLER_API CCrashHandler {
public:
	CCrashHandler(void);
	// TODO: add your methods here.
};

extern CRASHHANDLER_API int nCrashHandler;

CRASHHANDLER_API int fnCrashHandler(void);



// The generic custom exception
class CRASHHANDLER_API NTException
{
public:
    typedef const void* Address;
    virtual const char* what() const { return mWhat; };
    Address where() const { return mWhere; };
    unsigned code() const { return mCode; };
    NTException(const EXCEPTION_POINTERS* info);
    static void translate(unsigned code, EXCEPTION_POINTERS* info);
private:
    const char* mWhat;
    Address mWhere;
    unsigned mCode;
};


// Specific Exception to handle crashes
class CRASHHANDLER_API AccessViolation: public NTException
{
public:
    bool isWrite() const { return mIsWrite; };
    Address badAddress() const { return mBadAddress; };
private:
    bool mIsWrite;
    Address mBadAddress;
    AccessViolation(const EXCEPTION_POINTERS* info);
    friend void NTException::translate(unsigned code, EXCEPTION_POINTERS* info);
};